// DriversView.cpp : implementation file
//

#include "stdafx.h"
#include "odbcview.h"
#include "DriversView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDriversView property page

CDriversView::CDriversView(UINT nIDCaption) : CPSParent(nIDCaption)
{
	//{{AFX_DATA_INIT(CDriversView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CDriversView::~CDriversView()
{
}

void CDriversView::DoDataExchange(CDataExchange* pDX)
{
	CPSParent::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDriversView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDriversView, CPSParent)
	//{{AFX_MSG_MAP(CDriversView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDriversView message handlers

BOOL CDriversView::OnInitDialog() 
{
	CPSParent::OnInitDialog();
	
	// TODO: Add extra initialization here
	// here's the important part of this class
	// we use SQLDrivers() to enumerate all
	// ODBC drivers Installed on the system
	// and display their information
	SQLCHAR		szDriverName[200];
	SQLCHAR		szAttr[1024];
	SQLSMALLINT	NameLen, AttrLen;
	SQLHENV		hEnv = ((COdbcviewApp*)AfxGetApp())->m_hEnv;
	SQLRETURN	ret;

	ret = SQLDrivers ( hEnv, SQL_FETCH_FIRST, 
						szDriverName, sizeof(szDriverName), &NameLen,
						szAttr, sizeof(szAttr), &AttrLen );

	while ( SQL_SUCCEEDED ( ret ) && ret != SQL_NO_DATA )
	{
		// add the driver to the list
		m_wndList.InsertItem ( 0, (LPCTSTR)szDriverName );
		m_wndList.SetItem ( 0, 1, LVIF_TEXT, (LPCTSTR)szAttr, 0, 0, 0, 0 );
		
		// get next item
		ret = SQLDrivers ( hEnv, SQL_FETCH_NEXT, 
							szDriverName, sizeof(szDriverName), &NameLen,
							szAttr, sizeof(szAttr), &AttrLen );
	}
	if ( ret != SQL_NO_DATA )
	{
		// there was an error in the enumeration
		// show the message(s) to the user
		// (there might be more than one, so loop)
		SQLCHAR			szSqlState[10];
		SQLINTEGER		iNativeError;
		SQLCHAR			szMessage[SQL_MAX_MESSAGE_LENGTH];
		TCHAR			szDisplay[1024];
		int				i = 1;

		while ( SQLGetDiagRec ( SQL_HANDLE_ENV, hEnv, i, szSqlState, &iNativeError,
								szMessage, sizeof(szMessage), NULL ) != SQL_NO_DATA )
		{
			wsprintf ( szDisplay, _T("SQLSTATE %s, Native Error %d: %s"), 
						szSqlState, iNativeError, szMessage );
			AfxMessageBox ( szDisplay, MB_OK, 0 );
			++i;
		}

	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
