// PSParent.cpp : implementation file
//

#include "stdafx.h"
#include "odbcview.h"
#include "PSParent.h"
#include "AboutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// this parent class is only used for deriving all property sheets, since
// they all implement common behavior.
// basically, it prepares the list control on OnInitDialog()
// Child classes should override OnInitDialog() and call CPSParent::OnInitDialog()
// before adding any items to it.

/////////////////////////////////////////////////////////////////////////////
// CPSParent property page

CPSParent::CPSParent(UINT nIDCaption) : CPropertyPage(CPSParent::IDD, nIDCaption)
{
	//{{AFX_DATA_INIT(CPSParent)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPSParent::~CPSParent()
{
}

void CPSParent::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPSParent)
	DDX_Control(pDX, IDC_LIST, m_wndList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPSParent, CPropertyPage)
	//{{AFX_MSG_MAP(CPSParent)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPSParent message handlers

BOOL CPSParent::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// create column headers for the 
	// list control
	CRect rc; m_wndList.GetClientRect ( &rc );
	m_wndList.InsertColumn ( 0, _T("Name"), LVCFMT_LEFT, rc.Width ()/2, 0 );
	m_wndList.InsertColumn ( 1, _T("Commment"), LVCFMT_LEFT, rc.Width ()/2, 1 );
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPSParent::PopulateDSNList(DSN_TYPE DSNType)
{
		// Use SQLDataSources() to enumerate user data sources
	SQLHENV		hEnv = ((COdbcviewApp*)AfxGetApp())->m_hEnv;
	SQLCHAR		szDsnName[200];
	SQLCHAR		szDesc[200];
	SQLSMALLINT NameLen, DescLen;
	SQLRETURN	ret;
	
	SQLUSMALLINT dir;
	
	// find out which kind to enumerate
	switch ( DSNType )
	{
	case DSN_USER:
		dir = SQL_FETCH_FIRST_USER; break;
	case DSN_SYSTEM:
		dir = SQL_FETCH_FIRST_SYSTEM; break;
	case DSN_ANY:
		dir = SQL_FETCH_FIRST; break;
	}

	ret = SQLDataSources ( hEnv, dir, 
							szDsnName, sizeof(szDsnName), &NameLen,
							szDesc, sizeof(szDesc), &DescLen );

	while ( SQL_SUCCEEDED ( ret ) && ret != SQL_NO_DATA )
	{
		m_wndList.InsertItem ( 0, (LPCTSTR)szDsnName );
		m_wndList.SetItem ( 0, 1, LVIF_TEXT, (LPCTSTR)szDesc, 0, 0, 0, 0 );
		// get next dsn
		ret = SQLDataSources ( hEnv, SQL_FETCH_NEXT, 
								szDsnName, sizeof(szDsnName), &NameLen,
								szDesc, sizeof(szDesc), &DescLen );
	}
	if ( ret != SQL_NO_DATA )
	{
		// there was an error in the enumeration
		// show the message(s) to the user
		// (there might be more than one, so loop)
		SQLCHAR			szSqlState[10];
		SQLINTEGER		iNativeError;
		SQLCHAR			szMessage[SQL_MAX_MESSAGE_LENGTH];
		TCHAR			szDisplay[1024];
		int				i = 1;

		while ( SQLGetDiagRec ( SQL_HANDLE_ENV, hEnv, i, szSqlState, &iNativeError,
								szMessage, sizeof(szMessage), NULL ) != SQL_NO_DATA )
		{
			wsprintf ( szDisplay, _T("SQLSTATE %s, Native Error %d: %s"), 
						szSqlState, iNativeError, szMessage );
			AfxMessageBox ( szDisplay, MB_OK, 0 );
			++i;
		}

	}


}

void CPSParent::OnAbout() 
{
	// display about dialog box
	CAboutDlg	dlg;
	dlg.DoModal ();
	
}
