// odbcview.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "odbcview.h"
#include "UserDSNView.h"
#include "SysDSNView.h"
#include "DriversView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COdbcviewApp

BEGIN_MESSAGE_MAP(COdbcviewApp, CWinApp)
	//{{AFX_MSG_MAP(COdbcviewApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COdbcviewApp construction

COdbcviewApp::COdbcviewApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_hEnv = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only COdbcviewApp object

COdbcviewApp theApp;

/////////////////////////////////////////////////////////////////////////////
// COdbcviewApp initialization

BOOL COdbcviewApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// initialize the ODBC environment handle that will be
	// used throughout the applicaiton
	if ( !SQL_SUCCEEDED ( SQLAllocHandle ( SQL_HANDLE_ENV, SQL_NULL_HANDLE, &m_hEnv ) ) )
	{
		AfxMessageBox ( IDE_INITERROR, MB_OK, 0 );
		return FALSE;
	}
	// set ODBC version to 3.0
	SQLSetEnvAttr ( m_hEnv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER)SQL_OV_ODBC3, SQL_IS_INTEGER );

	CPropertySheet ps ( IDR_MAINTITLE );
	//m_pMainWnd = &ps;

	// add property pages
	CUserDSNView	userdsn ( IDR_USERDSN );
	CSysDSNView		sysdsn ( IDR_SYSDSN );
	CDriversView	drivers ( IDR_DRIVERS );

	ps.AddPage ( &userdsn );
	ps.AddPage ( &sysdsn );
	ps.AddPage ( &drivers );

	int nResponse = ps.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// uninitialize ODBC environment 
	SQLFreeHandle ( SQL_HANDLE_ENV, m_hEnv );

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
